| Home · All Classes · All Namespaces · Modules · Functions · Files

Public Slots | Signals | Public Member Functions | Static Public Member Functions | Protected Member Functions
Tp::Client::ConnectionInterfaceContactBlockingInterface Class Reference
Connection proxies

`#include <TelepathyQt/Connection>`

Inherits Tp::AbstractInterface.

List of all members.

## Public Slots

- QDBusPendingReply BlockContacts (const Tp::UIntList &contacts, bool reportAbusive, int timeout=-1)
- QDBusPendingReply UnblockContacts (const Tp::UIntList &contacts, int timeout=-1)
- QDBusPendingReply
  < Tp::HandleIdentifierMap > RequestBlockedContacts (int timeout=-1)

## Signals

- void BlockedContactsChanged (const Tp::HandleIdentifierMap &blockedContacts, const Tp::HandleIdentifierMap &unblockedContacts)

## Public Member Functions

- ConnectionInterfaceContactBlockingInterface (const QString &busName, const QString &objectPath, QObject *parent=0)
- ConnectionInterfaceContactBlockingInterface (const QDBusConnection &connection, const QString &busName, const QString &objectPath, QObject *parent=0)
- ConnectionInterfaceContactBlockingInterface (Tp::DBusProxy *proxy)
- ConnectionInterfaceContactBlockingInterface (const Tp::Client::ConnectionInterface &mainInterface)
- ConnectionInterfaceContactBlockingInterface (const Tp::Client::ConnectionInterface &mainInterface, QObject *parent)
- Tp::PendingVariant * requestPropertyContactBlockingCapabilities () const
- Tp::PendingVariantMap * requestAllProperties () const

## Static Public Member Functions

- static QLatin1String staticInterfaceName ()

## Protected Member Functions

- virtual void invalidate (Tp::DBusProxy *, const QString &, const QString &)

## Detailed Description

Proxy class providing a 1:1 mapping of the D-Bus interface "org.freedesktop.Telepathy.Connection.Interface.ContactBlocking".

## Constructor & Destructor Documentation

Tp::Client::ConnectionInterfaceContactBlockingInterface::ConnectionInterfaceContactBlockingInterface | ( | const QString & | busName,
|  | const QString & | objectPath,
|  | QObject * | parent = `0`
| ) |  |

Creates a ConnectionInterfaceContactBlockingInterface associated with the given object on the session bus.

Parameters:

  busName | Name of the service the object is on.
  objectPath | Path to the object on the service.
  parent | Passed to the parent class constructor.

Tp::Client::ConnectionInterfaceContactBlockingInterface::ConnectionInterfaceContactBlockingInterface | ( | const QDBusConnection & | connection,
|  | const QString & | busName,
|  | const QString & | objectPath,
|  | QObject * | parent = `0`
| ) |  |

Creates a ConnectionInterfaceContactBlockingInterface associated with the given object on the given bus.

Parameters:

  connection | The bus via which the object can be reached.
  busName | Name of the service the object is on.
  objectPath | Path to the object on the service.
  parent | Passed to the parent class constructor.

Tp::Client::ConnectionInterfaceContactBlockingInterface::ConnectionInterfaceContactBlockingInterface | ( | Tp::DBusProxy * | proxy | ) |

Creates a ConnectionInterfaceContactBlockingInterface associated with the same object as the given proxy.

Parameters:

  proxy | The proxy to use. It will also be the QObject::parent() for this object.

Tp::Client::ConnectionInterfaceContactBlockingInterface::ConnectionInterfaceContactBlockingInterface | ( | const Tp::Client::ConnectionInterface & | mainInterface | ) | `[explicit]`

Creates a ConnectionInterfaceContactBlockingInterface associated with the same object as the given proxy. Additionally, the created proxy will have the same parent as the given proxy.

Parameters:

  mainInterface | The proxy to use.

Tp::Client::ConnectionInterfaceContactBlockingInterface::ConnectionInterfaceContactBlockingInterface | ( | const Tp::Client::ConnectionInterface & | mainInterface,
|  | QObject * | parent
| ) |  |

Creates a ConnectionInterfaceContactBlockingInterface associated with the same object as the given proxy. However, a different parent object can be specified.

Parameters:

  mainInterface | The proxy to use.
  parent | Passed to the parent class constructor.

## Member Function Documentation

static QLatin1String Tp::Client::ConnectionInterfaceContactBlockingInterface::staticInterfaceName | ( |  | ) | `[inline, static]`

Returns the name of the interface "org.freedesktop.Telepathy.Connection.Interface.ContactBlocking", which this class represents.

Returns:
  The D-Bus interface name.

Tp::PendingVariant* Tp::Client::ConnectionInterfaceContactBlockingInterface::requestPropertyContactBlockingCapabilities | ( |  | ) | const`[inline]`

Asynchronous getter for the remote object property `ContactBlockingCapabilities` of type `uint`.

Additional capabilities for contact blocking; currently, this is limited to whether contacts may be reported as abusive.

Note that there is no capability for supporting blocking itself: the presence of this interface on a ConnectionInterface indicates that blocking contacts is supported.

Returns:
  A pending variant which will emit finished when the property has been retrieved.

Tp::PendingVariantMap* Tp::Client::ConnectionInterfaceContactBlockingInterface::requestAllProperties | ( |  | ) | const`[inline]`

Request all of the DBus properties on the interface.

Returns:
  A pending variant map which will emit finished when the properties have been retrieved.

QDBusPendingReply Tp::Client::ConnectionInterfaceContactBlockingInterface::BlockContacts | ( | const Tp::UIntList & | contacts,
|  | bool | reportAbusive,
|  | int | timeout = `-1`
| ) |  | `[inline, slot]`

Begins a call to the D-Bus method `BlockContacts` on the remote object.

Direct the server to block some contacts. The precise effect is protocol-dependent, but SHOULD include ignoring all current and subsequent communications from the given contacts, avoiding sending presence to them in future, and if they were already receiving the local user's presence, behaving as if the local user went offline.

Note that timeout is ignored as of now. It will be used once http://bugreports.qt.nokia.com/browse/QTBUG-11775 is fixed.

Parameters:

  contacts | Some contacts to block. If some of the contacts in this list are already blocked, the connection manager MUST act as if they were not specified in this list.

  reportAbusive

  In addition to blocking, report these contacts as abusive to the server administrators.

  Clients can determine whether this capability is available by checking the ContactBlockingCapabilities property. If this argument is set to `True` by a client despite ContactBlockingCapabilities not containing the `Can_Report_Abusive` flag, the connection manager SHOULD act as if it were `False` and simply block the supplied contacts.

  A correct user interface shouldn't get this far without knowing that reporting abusive contacts is not supported. If it does, then the user has expressed their intention to block these contacts. Returning an error would leave the UI with three options:
  - Ignore the error, leaving the contacts not actually blocked;
  - Display an error to the user;
  - Call this method again, passing `False` for this argument.

  None of these seem preferable to the CM just ignoring this flag if it doesn't support it: that way, the contacts will be blocked, as the user requested, and UIs have fewer ways to mess up entirely.

  timeout | The timeout in milliseconds.

QDBusPendingReply Tp::Client::ConnectionInterfaceContactBlockingInterface::UnblockContacts | ( | const Tp::UIntList & | contacts,
|  | int | timeout = `-1`
| ) |  | `[inline, slot]`

Begins a call to the D-Bus method `UnblockContacts` on the remote object.

Direct the server to unblock some contacts.

Note that timeout is ignored as of now. It will be used once http://bugreports.qt.nokia.com/browse/QTBUG-11775 is fixed.

Parameters:

  contacts | Some contacts to unblock. If some of the contacts in this list are not currently blocked, the connection manager MUST act as if they were not specified in this list.
  timeout | The timeout in milliseconds.

QDBusPendingReply<Tp::HandleIdentifierMap> Tp::Client::ConnectionInterfaceContactBlockingInterface::RequestBlockedContacts | ( | int | timeout = `-1` | ) | `[inline, slot]`

Begins a call to the D-Bus method `RequestBlockedContacts` on the remote object.

List the contacts that are blocked.

Clients SHOULD allow a relatively long timeout for calls to this method, since on some protocols contact blocking is part of the contact list, which can take a significant time to retrieve.

Note that timeout is ignored as of now. It will be used once http://bugreports.qt.nokia.com/browse/QTBUG-11775 is fixed.

Parameters:

  timeout | The timeout in milliseconds.

Returns:

The blocked contacts’ handles, together with their identifiers.

void Tp::Client::ConnectionInterfaceContactBlockingInterface::BlockedContactsChanged | ( | const Tp::HandleIdentifierMap & | blockedContacts,
|  | const Tp::HandleIdentifierMap & | unblockedContacts
| ) |  | `[signal]`

Represents the signal `BlockedContactsChanged` on the remote object.

Emitted when the list of blocked contacts is first retrieved (before returning from any pending calls to RequestBlockedContacts() ), and whenever the list of blocked contacts subsequently changes.

Parameters:

  blockedContacts | Contacts added to the result of RequestBlockedContacts.
  unblockedContacts | Contacts removed from the result of RequestBlockedContacts.

void Tp::Client::ConnectionInterfaceContactBlockingInterface::invalidate | ( | Tp::DBusProxy * | proxy,
|  | const QString & | error,
|  | const QString & | message
| ) |  | `[protected, virtual]`

Reimplemented from Tp::AbstractInterface.